<template>
  <div>
    <el-table :data="result ? result.coverImages : []">
      <el-table-column type="index" width="50" />
      <el-table-column label="Image">
        <template slot-scope="scope">
          <img :src="`/storage/${scope.row.url}`" style="width: 100px; height: 100px; object-fit: cover" />
        </template>
      </el-table-column>

      <el-table-column label="Blurhash" prop="blurhash" />

      <el-table-column align="right">
        <template #header>
          <el-button type="primary" @click="dialogVisible = true">
            Add
          </el-button>
        </template>
        <template slot-scope="scope">
          <el-button
            type="primary"
            plain=""
            size="small"
            @click="editItem(scope.row)"
          >
            Edit
          </el-button>

          <el-button
            type="danger"
            plain=""
            size="small"
            @click="deleteMenuItem(scope.row)"
          >
            Delete
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <el-dialog
      :title="newItem.id ? 'Edit menu item' : 'Add menu item'"
      :visible.sync="dialogVisible"
      width="450px"
    >
      <el-form :model="newItem" @submit.native.prevent>
        <el-upload
          class="avatar-uploader"
          action=""
          :before-upload="onUploadPhoto"
          :on-remove="onRemovePhoto"
          :on-success="onRenderSuccess"
          :show-file-list="false"
        >
          <template v-if="newItem.url">
            <img :src="newItem.url" class="avatar" />
          </template>
          <el-button v-else type="primary"> Click to upload image </el-button>
        </el-upload>
        <br />
        <el-form-item>
          <el-checkbox v-model="newItem.desktop_active">
            Desktop active
          </el-checkbox>
        </el-form-item>
        <el-form-item>
          <el-checkbox v-model="newItem.mobile_active">
            Mobile active
          </el-checkbox>
        </el-form-item>
      </el-form>
      <span slot="footer" class="dialog-footer">
        <el-button @click="dialogVisible = false">Cancel</el-button>
        <el-button type="primary" @click="addItem">
          {{ newItem.id ? 'Save' : 'Add' }}
        </el-button>
      </span>
    </el-dialog>
  </div>
</template>

<script lang="ts">
import {
  defineComponent,
  ref,
  watch,
  useContext,
  computed
} from '@nuxtjs/composition-api'
import { ImageItem } from '@/types'
import { CoverImageFragment } from '@/sdk/types'
import {
  useAdminGetCoverImagesQuery,
  useAdminDeleteCoverImagesMutation,
  useAdminAddCoverImagesMutation
} from '~/sdk/hooks'

type Item = {
  id: string | null
  url: string
  blurhash: string
  desktop_active: boolean
  mobile_active: boolean
}

export default defineComponent({
  name: 'AdminSliderForm',
  props: ['type'],
  setup(_, { root }) {
    const { result, refetch } = useAdminGetCoverImagesQuery()

    const { app } = useContext()
    const user = computed(() => root.$accessor.auth.user)

    // photo upload
    const photosData = ref<Array<ImageItem>>([])
    const photosDataForRemove = ref<Array<ImageItem>>([])
    const fileName = (file: any) => {
      return Date.now() + '.' + /[^.]+$/.exec(file)
    }
    const onUploadPhoto = async (file: File) => {
      try {
        const { key, blurhash } = await app.$api.storage.upload(
          `public/web/${user.value?.id}/${fileName(file.name)}`,
          file,
          {
            with_blurhash: true
          }
        )
        const imageData: ImageItem = {
          blurhash: blurhash,
          url: app.$api.storage.getUrl(key)
        }
        photosData.value.push(imageData)
        newItem.value.blurhash = blurhash
      } catch (e) {
        console.log(e)
      } finally {
        console.log('success')
        console.log(photosData.value)
      }
    }
    const onRemovePhoto = async (file: ImageItem) => {
      const index = photosData.value.findIndex((e, i) => e === file)
      photosDataForRemove.value.push(photosData.value[index])
      photosData.value.splice(index, 1)
    }

    const onRenderSuccess = (res: any, file: any) => {
      newItem.value.url = URL.createObjectURL(file.raw)
    }

    // create item slider

    const dialogVisible = ref(false)
    const newItem = ref<Item>(createItem())

    function createItem(): Item {
      const item: Item = {
        id: null,
        url: '',
        blurhash: '',
        desktop_active: false,
        mobile_active: false
      }

      return item
    }

    const { mutate: deleteMutate } = useAdminDeleteCoverImagesMutation({
      errorPolicy: 'all',
      context: {
        headers: {
          'x-hasura-role': 'administrator'
        }
      }
    })
    function deleteMenuItem(item: CoverImageFragment) {
      root.$confirm(`Delete item?`, {
        type: 'warning',
        confirmButtonText: 'OK',
        cancelButtonText: 'Cancel',
        center: true,
        async callback(action) {
          if (action === 'confirm') {
            await deleteMutate({ id: item.id })
            await app.$api.storage.delete(item.url)
          }
          await refetch()
        }
      })
    }
    function editItem(item: CoverImageFragment) {
      const editItem = createItem()
      editItem.id = item.id
      editItem.url = '/storage/' + item.url
      editItem.blurhash = item.blurhash
      editItem.desktop_active = item.desktop_active
      editItem.mobile_active = item.mobile_active
      newItem.value = editItem
      dialogVisible.value = true
    }
    const { mutate } = useAdminAddCoverImagesMutation({
      errorPolicy: 'all',
      context: {
        headers: {
          'x-hasura-role': 'administrator'
        }
      }
    })
    async function addItem() {
      await mutate({
        item: {
          id: newItem.value.id || undefined,
          url: photosData.value[0].url,
          blurhash: photosData.value[0].blurhash,
          desktop_active: newItem.value.desktop_active,
          mobile_active: newItem.value.mobile_active
        }
      })
      await refetch()
      dialogVisible.value = false
    }

    watch(dialogVisible, value => {
      if (!value) newItem.value = createItem()
    })

    return {
      result,
      addItem,
      dialogVisible,
      newItem,
      deleteMenuItem,
      editItem,

      onUploadPhoto,
      onRemovePhoto,
      onRenderSuccess
    }
  }
})
</script>
